POJ2157Maze[DFS !]

Maze

Time Limit: 2000MS   Memory Limit: 65536K
Total Submissions: 3818   Accepted: 1208

Description

Acm, a treasure-explorer, is exploring again. This time he is in a special maze, in which there are some doors (at most 5 doors, represented by ‘A‘, ‘B‘, ‘C‘, ‘D‘, ‘E‘ respectively). In order to find the treasure, Acm may need to open doors. However, to open a door he needs to find all the door‘s keys (at least one) in the maze first. For example, if there are 3 keys of Door A, to open the door he should find all the 3 keys first (that‘s three ‘a‘s which denote the keys of ‘A‘ in the maze). Now make a program to tell Acm whether he can find the treasure or not. Notice that Acm can only go up, down, left and right in the maze.

Input

The input consists of multiple test cases. The first line of each test case contains two integers M and N (1 < N, M < 20), which denote the size of the maze. The next M lines give the maze layout, with each line containing N characters. A character is one of the following: ‘X‘ (a block of wall, which the explorer cannot enter), ‘.‘ (an empty block), ‘S‘ (the start point of Acm), ‘G‘ (the position of treasure), ‘A‘, ‘B‘, ‘C‘, ‘D‘, ‘E‘ (the doors), ‘a‘, ‘b‘, ‘c‘, ‘d‘, ‘e‘ (the keys of the doors). The input is terminated with two 0‘s. This test case should not be processed.

Output

For each test case, in one line output "YES" if Acm can find the treasure, or "NO" otherwise.

Sample Input

4 4
S.X.
a.X.
..XG
....
3 4
S.Xa
.aXB
b.AG
0 0

Sample Output

YES
NO

Source

POJ Monthly,Wang Yijie


题意:迷宫,有门有钥匙


1.多个G,不能简单记录终点

2.有的门没钥匙,就是不能进

不需要回溯,一边搜下去,遇到钥匙判断一下这个钥匙凑齐了没有,如果凑齐了则增加从这个钥匙能打开的门开始搜索(用mark表示这个门有没有到达过)

//
//  main.cpp
//  poj2157
//
//  Created by Candy on 10/1/16.
//  Copyright © 2016 Candy. All rights reserved.
//

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <vector>
#include <string>
using namespace std;
const int N=21,V=1e6+5;
inline int read(){
    char c=getchar();int x=0,f=1;
    while(c<‘0‘||c>‘9‘){if(c==‘-‘)f=-1;c=getchar();}
    while(c>=‘0‘&&c<=‘9‘){x=x*10+c-‘0‘;c=getchar();}
    return x;
}
int n,m,sx,sy,flag=0;
char a[N][N];
struct doors{
    int k,x,y;
}door[N*N];
int cnt=0;
int vis[N][N],g[N][N],dx[4]={-1,1,0,0},dy[4]={0,0,1,-1};
struct keys{
    int has,tot;
}key[N];
int mark[N][N];
void dfs(int x,int y){//printf("dfs %d %d\n",x,y);
    vis[x][y]=1;
    if(a[x][y]==‘G‘){flag=1;return;}
    if(flag) return;
    for(int i=0;i<4;i++){
        int nx=x+dx[i],ny=y+dy[i];
        if(vis[nx][ny]) continue;
        if(nx<1||nx>n||ny<1||ny>m) continue;
        if(g[nx][ny]<=5&&g[nx][ny]>=1){
            int num=g[nx][ny];
            mark[nx][ny]=1;
            if(key[num].has<key[num].tot||(!key[num].tot)) continue;
        }
        if(g[nx][ny]>5) {
            int num=g[nx][ny]-5;
            key[num].has++;
            if(key[num].has==key[num].tot&&key[num].tot){//no key cannot in
                for(int j=1;j<=cnt;j++)
                    if(door[j].k==num&&mark[door[j].x][door[j].y]){
                        dfs(door[j].x,door[j].y);
                    }
            }
        }
        dfs(nx,ny);
    }
    //printf("end %d %d\n",x,y);
}
int main(int argc, const char * argv[]) {
    while(scanf("%d%d",&n,&m)&&n){
        memset(g,0,sizeof(g));
        memset(vis,0,sizeof(vis));
        memset(door,0,sizeof(door));
        memset(key,0,sizeof(key));
        memset(mark,0,sizeof(mark));
        cnt=0;
        for(int i=1;i<=n;i++){
            flag=0;
            scanf("%s",a[i]+1);
            for(int j=1;j<=m;j++){
                if(a[i][j]==‘S‘) sx=i,sy=j;
                else if(a[i][j]==‘X‘) vis[i][j]=1;
                else if(a[i][j]>=‘A‘&&a[i][j]<=‘E‘){
                    g[i][j]=a[i][j]-‘A‘+1;//1...5
                    door[++cnt].x=i;door[cnt].y=j;door[cnt].k=g[i][j];
                }else if(a[i][j]>=‘a‘&&a[i][j]<=‘e‘){
                    key[a[i][j]-‘a‘+1].tot++;
                    g[i][j]=a[i][j]-‘a‘+6;//6...10
                }
            }
        }
        dfs(sx,sy);
        if(flag) puts("YES");
        else puts("NO");
        //printf("%d %d %d",key[2].has,key[2].tot,door[2].k);
    }

    return 0;
}
时间: 2024-07-30 13:46:15

POJ2157Maze[DFS !]的相关文章

解救小哈——DFS算法举例

一.问题引入 有一天,小哈一个人去玩迷宫.但是方向感不好的小哈很快就迷路了.小哼得知后便去解救无助的小哈.此时的小哼已经弄清楚了迷宫的地图,现在小哼要以最快的速度去解救小哈.那么,问题来了... 二.问题的分析 首先我们用一个二维数组来存储这个迷宫,刚开始的时候,小哼处于迷宫的入口处(1,1),小哈在(p,q).其实这道题的的本质就在于找从(1,1)到(p,q)的最短路径. 此时摆在小哼面前的路有两条,我们可以先让小哼往右边走,直到走不通的时候再回到这里,再去尝试另外一个方向. 在这里我们规定一

【BZOJ4942】[Noi2017]整数 线段树+DFS(卡过)

[BZOJ4942][Noi2017]整数 题目描述去uoj 题解:如果只有加法,那么直接暴力即可...(因为1的数量最多nlogn个) 先考虑加法,比较显然的做法就是将A二进制分解成log位,然后依次更新这log位,如果最高位依然有进位,那么找到最高位后面的第一个0,将中间的所有1变成0,那个0变成1.这个显然要用到线段树,但是复杂度是nlog2n的,肯定过不去. 于是我在考场上yy了一下,这log位是连续的,我们每次都要花费log的时间去修改一个岂不是很浪费?我们可以先在线段树上找到这段区间

uva1103(dfs)

UVA - 1103 还是没写好,,看的别人的 1 #include <iostream> 2 #include <cstdio> 3 #include <cmath> 4 #include <cstring> 5 #include <algorithm> 6 #include <cstdlib> 7 #include <stack> 8 #include <cctype> 9 #include <str

poj 1088 滑雪 DP(dfs的记忆化搜索)

题目地址:http://poj.org/problem?id=1088 题目大意:给你一个m*n的矩阵 如果其中一个点高于另一个点 那么就可以从高点向下滑 直到没有可以下滑的时候 就得到一条下滑路径 求最大的下滑路径 分析:因为只能从高峰滑到低峰,无后效性,所以每个点都可以找到自己的最长下滑距离(只与自己高度有关).记忆每个点的最长下滑距离,当有另一个点的下滑路径遇到这个点的时候,直接加上这个点的最长下滑距离. dp递推式是,dp[x][y] = max(dp[x][y],dp[x+1][y]+

蓝桥杯 大臣的旅费_树的最长度_两次DFS

#include <iostream> #include <cstdio> #include <cstdlib> #include <algorithm> #include <cstring> #include <functional> #include <vector> using namespace std; const int maxn = 1000000 + 10; const int INF = 10000000

A. The Fault in Our Cubes 暴力dfs

http://codeforces.com/gym/101257/problem/A 把它固定在(0,0, 0)到(2, 2, 2)上,每次都暴力dfs检查,不会超时的,因为规定在这个空间上,一不行,就会早早退出. 这样写起来比较好写. #include <cstdio> #include <cstdlib> #include <cstring> #include <cmath> #include <algorithm> #include <

codeforces717E Paint it really, really dark gray(树上dfs)

题意: 给你一棵树,2e5个节点,每个节点有一种颜色(黑色或粉色) 让你从节点1开始,自由沿边行走,到达节点时会把这个节点的颜色改变 要求你输出任意一条路径使得从节点1出发,所有节点的颜色都变为黑色 思路: 很明显要递归遍历 每到达一个节点就先改变节点的颜色标志并输出当前节点 如果当前到达了叶子节点,则不用进行操作 返回上层节点时再改变节点的颜色标志并输出当前节点,然后判断叶子节点的颜色,如果为粉色,则再到达一次叶子节点再回到当前节点 这样确保当前节点的所有儿子节点都为黑色的 然后就这样一直递归

POJ2488 dfs

A Knight's Journey Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 41972   Accepted: 14286 Description Background The knight is getting bored of seeing the same black and white squares again and again and has decided to make a journey ar

BZOJ_1016_[JSOI2008]_最小生成树计数_(dfs+乘法原理)

描述 http://www.lydsy.com/JudgeOnline/problem.php?id=1016 给出一张图,其中具有相同权值的边的数目不超过10,求最小生成树的个数. 分析 生成树的计数有一个什么什么算法... 我真的企图研究了...但是智商捉急的我实在看不懂论文... 所以最后还是写了暴力... 当然暴力也要靠正确的姿势的. 首先来看一个结论: 同一张图的所有最小生成树中,边权值相同的边的数目是一定的. 也就是说,假如某一张图的某一棵最小生成树由边权值为1,1,2,2,2,3的